<template>
    <NuxtLayout :name="'dashboard'">
        <div class="container p-8">
            <!-- <Toast :visible="toastVisible" :title="toastTitle" :message="toastMessage" /> -->
            <CustomTable :tableName="tableName" :currentPage="currentPage" :limitPerPage="itemPerPage" :heads="heads"
                :items="files" :addPath="isWarga ? '/application/new' : ''" @on-search="search"
                @approve-application="approveApplication" @reject-application="rejectApplication"
                @download-report="downloadReport" @page-change="pageUpdate" />
        </div>
    </NuxtLayout>
</template>

<script lang="ts">

definePageMeta({
    middleware: ["auth"],
});

export default {
    layout: "dashboard",
    data() {
        return {
            toastVisible: false,
            toastTitle: "",
            toastMessage: "",
            tableName: "Files",
            isLoading: false,
            currentPage: 1,
            itemPerPage: 10,
            heads: [
                "No",
                "Description",
                "Status",
                "Created At",
                "Owner Name",
                "Owner Email",
                "Action",
            ],
            files: [],
        };
    },
    mounted() {
        this.fetchData();
    },
    computed: {
        isWarga: () => {
            const userStore = useUserDataStore();
            return userStore.role === 'warga' ? true : false;
        }
    },
    methods: {
        fetchData(query: string = '') {
            this.isLoading = true;
            const toastStore = useToastStore();
            const userData = useUserDataStore();
            const accessToken = localStorage.getItem("access_token");
            const config = useRuntimeConfig();
            this.$api
                .get(`/application?search=${query}&page=${this.currentPage}&limit=${this.itemPerPage}`, {
                    headers: {
                        'Authorization': `Bearer ${accessToken}`,
                    },
                })
                .then((response) => {
                    let datas = response.data;
                    datas.map((item: any) => {
                        item.description = item.description === '' ? '-' : item.description;
                        item.status = item.status.charAt(0).toUpperCase() + item.status.slice(1);
                        item.date = new Date(item.created_at).toISOString().split('T')[0];
                        item.owner_name = item.owner.name;
                        item.owner_email = item.owner.email;
                        delete item.owner;
                        delete item.created_at;
                        item.action = [
                            {
                                icon: "solar:like-bold-duotone",
                                color: "bg-green-500",
                                callback: 'approve-application',
                                disabled: this.isWarga || item.status != 'Pending',
                            },
                            {
                                icon: "solar:dislike-bold-duotone",
                                color: "bg-red-500",
                                callback: 'reject-application',
                                disabled: this.isWarga || item.status != 'Pending',
                            },
                            {
                                icon: "material-symbols:edit-outline",
                                color: "bg-blue-500",
                                route: `/application/${item.id}`,
                                disabled: !this.isWarga || item.status != 'Pending' || item.owner_email != userData.email,
                            },
                            {
                                icon: "material-symbols:delete-outline-rounded",
                                color: "bg-red-500",
                                disabled: !this.isWarga || item.status != 'Pending',
                                callback: 'delete-file',
                            },
                            {
                                icon: "material-symbols:sim-card-download",
                                color: "bg-green-500",
                                disabled: item.status != 'Approved',
                                callback: 'download-report'
                            }
                        ];
                        delete item.file_path;
                    });
                    this.files = datas;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    toastStore.showToast(message, 'danger');
                }).finally(() => {
                    this.isLoading = false;
                })
        },
        search(query: string) {
            this.fetchData(query);
        },
        pageUpdate(page: number) {
            this.currentPage = page;
            this.fetchData();
        },
        approveApplication(id: number) {
            this.isLoading = true;
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;
            this.$api.put(`/application/${id}/approve`, {}, {
                headers: {
                    'Authorization': `Bearer ${accessToken}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    let owner_name = response.data.owner_name;
                    this.fetchData();
                    toastStore.showToast(`Application ${owner_name} has been approved`, 'success');
                    this.isLoading = false;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                    this.isLoading = false;
                })
        },
        rejectApplication(id: number) {
            this.isLoading = true;
            const toastStore = useToastStore();
            const accessToken: string = localStorage.getItem("access_token")!;
            this.$api.put(`/application/${id}/reject`, {}, {
                headers: {
                    'Authorization': `Bearer ${accessToken}`,
                },
            })
                .then((response) => {
                    console.log(response)
                    let title = response.data.title;
                    this.fetchData();
                    toastStore.showToast(`Application ${title} has been rejected`, 'success');
                    this.isLoading = false;
                })
                .catch((error) => {
                    console.log(error);
                    const detail = error.response.data.detail;
                    let message = "";
                    if (detail[0].msg) {
                        message = detail[0].msg;
                    } else {
                        message = detail;
                    }
                    this.fetchData();
                    toastStore.showToast(message, 'danger');
                    this.isLoading = false;
                })
        },
        async downloadReport(id: number) {
            this.isLoading = true;
            const toastStore = useToastStore();
            try {
                const response = await this.$api.get(`/application/${id}/report`, {
                    headers: {
                        Authorization: `Bearer ${localStorage.getItem('access_token')}`,
                    },
                    responseType: 'blob', // Important to handle binary data like a PDF
                });

                const url = window.URL.createObjectURL(new Blob([response.data]));
                const link = document.createElement('a');
                link.href = url;
                link.setAttribute('download', 'downloaded_file.pdf');
                document.body.appendChild(link);
                link.click();
                document.body.removeChild(link);
            } catch (error: any) {
                console.error('Error downloading PDF:', error);
                if (error.response.status == 404)
                    toastStore.showToast('File tidak ditemukan!', 'danger');
                else
                    toastStore.showToast(error.response.data.detail, 'danger');
            }
        }
    },
};
</script>
